{$mode objfpc}{$R+}{$I+}
uses
  SysUtils;
var
  matches: array of record W, L: Integer; end;
  players: array of record wins: Integer; opponents: array of Integer; end;
  answer: array of Integer;

  procedure Rec(AIndex, ALevel, AOffset: Integer);
  begin
    if ALevel < 0 then begin
      answer[AOffset] := AIndex + 1;
      exit;
    end;
    Rec(AIndex, ALevel - 1, AOffset);
    Rec(players[AIndex].opponents[ALevel] - 1, ALevel - 1, AOffset + (1 shl ALevel));
  end;

var
  i, mi, N: Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(N);
  SetLength(matches, 1 shl N - 1);
  SetLength(players, 1 shl N);
  for i := 0 to High(matches) do
    with matches[i] do begin
      Read(W, L);
      players[W - 1].wins += 1;
    end;
  mi := 0;
  for i := 0 to High(players) do
    with players[i] do begin
      SetLength(opponents, wins);
      if players[mi].wins < wins then
        mi := i;
    end;
  for i := 0 to High(matches) do
    with matches[i] do
      players[W - 1].opponents[players[L - 1].wins] := L;
  SetLength(answer, Length(players));
  Rec(mi, players[mi].wins - 1, 0);
  for i := 0 to High(answer) do
    Write(answer[i], ' ');
end.
